
function doMainOnLoad() {
    window.client = new MSNObject();
    
    LoadPrefs(window.client);
// Passwords Management
    var nsIPasswordManager = Components.interfaces.nsIPasswordManager;
    var nsIPassword = Components.interfaces.nsIPassword;
    var nsPM = Components.classes['@mozilla.org/passwordmanager;1'].createInstance(nsIPasswordManager);
    
    var reject = false;
    var e = nsPM.rejectEnumerator;
    while (e.hasMoreElements()) {
        var nsPass = e.getNext()
        nsPass.QueryInterface(nsIPassword);
        if (nsPass.host == 'msnmsgr.mozdev.org') {
            reject = true;
        }
    }
    if (!reject) {
        var e = nsPM.enumerator;
        while (e.hasMoreElements()) {
            var nsPass = e.getNext()
            nsPass.QueryInterface(nsIPassword);
            if (nsPass.host == 'msnmsgr.mozdev.org') {
                var popup = document.getElementById('email').firstChild;
                var mi = document.createElement('menuitem');
                mi.setAttribute('label', nsPass.user);
                mi.setAttribute('value', nsPass.user);
                mi.setAttribute('password', nsPass.password);
                popup.appendChild(mi);
            }
        }
    }
    if (!DEBUG) return;
// Log file
    var nsILocalFile = Components.interfaces.nsILocalFile;
    var nsIFileOutputStream = Components.interfaces.nsIFileOutputStream;
    
    var nsLF = Components.classes["@mozilla.org/file/local;1"].createInstance(nsILocalFile);
    nsLF.initWithPath("C:\\io.log");
    
    if (nsLF.exists())
        nsLF.remove(false);
        
    nsLF.create(0, 777);
    
    nsFOS = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(nsIFileOutputStream);
    nsFOS.init(nsLF, 3, 7, 0); /*  <--- no idea, just through numbers in as
                                        parameters till it worked */
}

function doMainOnUnLoad() {
    for (var s in window.client.Sessions) {
        var session = window.client.Sessions[s];
        session.exit();
        if (typeof(session._WINDOW) == "object")
            session._WINDOW.close();
    }
    window.client.logout();
    delete window.client;
    
    if (typeof(nsFOS) != 'object') return;
    nsFOS.close();
    delete nsFOS;
}

function doSignIn() {
    var email = document.getElementById('email');
    var re = /^.*\@.*\..*$/i;
    var m = re.exec(email.value);
    if (!m) {
        alert(window.client.bundle.GetStringFromName('invalidEMail'));
        return;
    }
    if (!email.selectedItem) {
        if (confirm(window.client.bundle.GetStringFromName('rememberPass'))) {
            var nsIPasswordManager = Components.interfaces.nsIPasswordManager;
            var nsPM = Components.classes['@mozilla.org/passwordmanager;1'].createInstance(nsIPasswordManager);
            nsPM.addUser('msnmsgr.mozdev.org', email.value, document.getElementById('password').value);
        }
    }
    if (CheckOnlineStatus()) {
        document.getElementById('main-pages').selectedIndex = 1;
        var ret = window.client.logon(email.value,
                                document.getElementById('password').value,
                                document.getElementById('initial-status').value);
        document.getElementById('signin-button').disabled = true;
    }
}

function doSignOut(timedout) {
    document.getElementById('signin-button').disabled = false;
    var pb = document.getElementById('SignInProgress')
    pb.mode = "undetermined";
    pb.value = "0%";
    document.getElementById('main-pages').selectedIndex = 0;
    window.client.logout();
    
    if (timedout)
        setTimeout('doSignIn()', 0);
}

function ChangeStatus(stat) {
    window.client.status = stat;
}

function AddContact() {
    openWindowOnce("chrome://msnmsgr/contact/addcontact.xul", "msnsmgr:add-contact", "chrome");
}

function SendIM(contact) {
    if (contact) {
        var tree = document.getElementById('contact-list-tree');
        var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
        
        var w = findOutGoingSessionWindowFor(item.id);
        if (w) {
            w._CONTACT = item.id;
            w._SESSION = new MSNSession(window.client, w);
            window.client.grabSessionFor(w._SESSION);
        }
    } else {
        var w = window.open('chrome://msnmsgr/content/session.xul', '_blank', 'chrome,resizable');
        w._SESSION = new MSNSession(window.client, w);
        window.client.grabSessionFor(w._SESSION);
    }
}

function SendEMail(contact) {
    var msncmd = 'COMPOSE';
    if (contact) {
        var tree = document.getElementById('contact-list-tree');
        var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
        msncmd += ' ' + item.id;
    }
    window.client.openURL(msncmd);
}

function ConfirmDelete() {
    var tree = document.getElementById('contact-list-tree');
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    if (confirm(window.client.bundle.GetStringFromName('contactDelete') + ' ' + item.getAttribute('label') + ' (' + item.id + ')')) {
        window.client.removeContact(item.id, 0, "FL");
    }
}

function ToggleBlock() {
    var tree = document.getElementById('contact-list-tree');
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    if (client.Contacts['BL'][item.id]) {
        client.Contacts['AL'][item.id] = client.Contacts['BL'][item.id];
        client.removeContact(item.id, 0, "BL");
        client.addContact(item.id, escape(item.getAttribute('nickname')), 0, "AL");
    } else {
        client.Contacts['BL'][item.id] = client.Contacts['AL'][item.id];
        client.removeContact(item.id, 0, "AL");
        client.addContact(item.id, escape(item.getAttribute('nickname')), 0, "BL");
    }
}

function ViewProfile() {
    var tree = document.getElementById('contact-list-tree');
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    
    window.open('http://members.msn.com/default.msnw?mem=' + item.id, '_BLANK');
}

function doContactClick(tree, event) {

}

function doContactDblClick(tree, event) {
    if (event.button != 0)
        return false;
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    if (item.id == 'emailItem') {
        window.client.openURL('INBOX');
    }
    else if (item.id != 'online' && item.id != 'offline') {
        //client.createSession(item.id);
        var w = findOutGoingSessionWindowFor(item.id); //window.open('chrome://msnmsgr/content/session.xul', '_blank', 'chrome,resizable');
        if (w) {
            w._CONTACT = item.id;
            w._SESSION = new MSNSession(window.client, w);
            window.client.grabSessionFor(w._SESSION);
        }
    }
}

function onContextMenu(tree, event) {
    var item = tree.view.getItemAtIndex(tree.currentIndex);
    var section = item.parentNode;
    var cell = item.firstChild.firstChild;
    if (cell.id == "online" || cell.id == "offline" || cell.id == "emailItem") {
        return false;
    }
    if (section.id == 'online-contacts-list') {
        
    } else if (section.id == 'offline-contacts-list') {
        
    }
}

window.OnActiveEmailChange =
function OnActiveEmailChange (Headers, Info) {
    if (Info['Src-Folder'] == 'ACTIVE') {
        window.client.email -= Info['Message-Delta'];
    }
    else if (Info['Dest-Folder'] == 'ACTIVE') {
        window.client.email = (window.client.email * 1) + (Info['Message-Delta'] * 1);
    }
    UpdateEmailItem(window.client.email);
}

window.OnEmailNotify =
function OnEmailNotify (Headers, Info) {
    window.client.email = (window.client.email * 1) + 1;
    UpdateEmailItem(window.client.email);
}

window.OnInitialEmailNotify =
function OnInitialEmailNotify(Headers, Info) {
    var emails = Info['Inbox-Unread'];
    window.client.email = Info['Inbox-Unread'];
    window.client.InboxURL = Info['Inbox-URL'];
    window.client.FoldersURL = Info['Folders-URL'];
    window.client.PostURL = Info['Post-URL'];
    UpdateEmailItem(emails);
}

window.OnSystemMessage =
function OnSystemMessage (Headers, Info) {
    
}

function UpdateEmailItem(emails) {
    if (emails == 0) {
        emails = window.client.bundle.GetStringFromName('noNewEmail');
    } else if (emails == 1) {
        emails = window.client.bundle.GetStringFromName('oneNewEmail');
    } else {
        emails = emails + ' ' +window.client.bundle.GetStringFromName('newEmail');
    }
    window.document.getElementById('emailItem').setAttribute('label', emails);
}